<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: cross_validate_regression_trainer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">cross_validate_regression_trainer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2010  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_CROSS_VALIDATE_REGRESSION_TRaINER_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_CROSS_VALIDATE_REGRESSION_TRaINER_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../statistics.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;cross_validate_regression_trainer_abstract.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">typename</span> reg_funct_type,</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">typename</span> sample_type,</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">typename</span> label_type</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        &gt;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    matrix&lt;double,1,2&gt;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    test_regression_function (</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keyword">const</span> reg_funct_type&amp; reg_funct,</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="keyword">const</span> std::vector&lt;sample_type&gt;&amp; x_test,</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keyword">const</span> std::vector&lt;label_type&gt;&amp; y_test</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    )</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        DLIB_ASSERT( is_learning_problem(x_test,y_test) == <span class="keyword">true</span>,</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                    <span class="stringliteral">&quot;\tmatrix test_regression_function()&quot;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot;\n\t is_learning_problem(x_test,y_test): &quot;</span> </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                    &lt;&lt; is_learning_problem(x_test,y_test));</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        running_stats&lt;double&gt; rs;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        running_scalar_covariance&lt;double&gt; rc;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; x_test.size(); ++i)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            <span class="comment">// compute error</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> output = reg_funct(x_test[i]);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> temp = output - y_test[i];</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            rs.add(temp*temp);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            rc.add(output, y_test[i]);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        }</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        matrix&lt;double,1,2&gt; result;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        result = rs.mean(), std::pow(rc.correlation(),2);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordflow">return</span> result;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">typename</span> trainer_type,</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">typename</span> sample_type,</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">typename</span> label_type </div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        &gt;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    matrix&lt;double,1,2&gt; </div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    cross_validate_regression_trainer (</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keyword">const</span> trainer_type&amp; trainer,</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keyword">const</span> std::vector&lt;sample_type&gt;&amp; x,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keyword">const</span> std::vector&lt;label_type&gt;&amp; y,</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> folds</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    )</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    {</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        DLIB_ASSERT(is_learning_problem(x,y) == <span class="keyword">true</span> &amp;&amp;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;                    1 &lt; folds &amp;&amp; folds &lt;= static_cast&lt;long&gt;(x.size()),</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            <span class="stringliteral">&quot;\tmatrix cross_validate_regression_trainer()&quot;</span></div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t invalid inputs were given to this function&quot;</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t x.size(): &quot;</span> &lt;&lt; x.size() </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t folds:  &quot;</span> &lt;&lt; folds </div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t is_learning_problem(x,y): &quot;</span> &lt;&lt; is_learning_problem(x,y)</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            );</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> num_in_test = x.size()/folds;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> num_in_train = x.size() - num_in_test;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        running_stats&lt;double&gt; rs;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        running_scalar_covariance&lt;double&gt; rc;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        std::vector&lt;sample_type&gt; x_test, x_train;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        std::vector&lt;label_type&gt; y_test, y_train;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keywordtype">long</span> next_test_idx = 0;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; folds; ++i)</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        {</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            x_test.clear();</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            y_test.clear();</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            x_train.clear();</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            y_train.clear();</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="comment">// load up the test samples</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> cnt = 0; cnt &lt; num_in_test; ++cnt)</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            {</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;                x_test.push_back(x[next_test_idx]);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;                y_test.push_back(y[next_test_idx]);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;                next_test_idx = (next_test_idx + 1)%x.size();</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            }</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="comment">// load up the training samples</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <span class="keywordtype">long</span> next = next_test_idx;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> cnt = 0; cnt &lt; num_in_train; ++cnt)</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            {</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;                x_train.push_back(x[next]);</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                y_train.push_back(y[next]);</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                next = (next + 1)%x.size();</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            }</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            <span class="keywordflow">try</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            {</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;                <span class="keyword">const</span> <span class="keyword">typename</span> trainer_type::trained_function_type&amp; df = trainer.train(x_train,y_train);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160; </div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;                <span class="comment">// do the training and testing</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> j = 0; j &lt; x_test.size(); ++j)</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;                {</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;                    <span class="comment">// compute error</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;                    <span class="keyword">const</span> <span class="keywordtype">double</span> output = df(x_test[j]);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;                    <span class="keyword">const</span> <span class="keywordtype">double</span> temp = output - y_test[j];</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;                    rs.add(temp*temp);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;                    rc.add(output, y_test[j]);</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;                }</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;            }</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            <span class="keywordflow">catch</span> (invalid_nu_error&amp;)</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            {</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                <span class="comment">// just ignore cases which result in an invalid nu</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            }</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        } <span class="comment">// for (long i = 0; i &lt; folds; ++i)</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        matrix&lt;double,1,2&gt; result;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        result = rs.mean(), std::pow(rc.correlation(),2);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordflow">return</span> result;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    }</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;}</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160; </div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="preprocessor">#endif // DLIB_CROSS_VALIDATE_REGRESSION_TRaINER_Hh_</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
